PROGRAM highway_havoc;
GLOBAL
 sfont;
 lfont;

 score;
 hiscore;

 difficulty=1;     //from 1 to 30
 prevdiff;

 music;
 carhitsound;
 pedhitsound;
 policesound;
 enginesound;
 skidsound;
 yellsound1;
 yellsound2;
 yellsound3;
 yellsound4;
 bigcombosound;
 hugecombosound;
 monstrouscombosound;
 explosionsound;
 hornsound1;
 hornsound2;

 lanecounter[3];
 lane;

 resetscroll;

 particles[11];

 cars[40];
 carid;

 carshadows[10];

 carlane;

 policecounter;

 busstopcounter;

 signcounter;

 combocounter;
 combokills;

 kills;

 gameover;

LOCAL
 speed;
 xspeed;
 addspeed;

 exploded;

 cpx[5];
 cpy[5];

 life;

 bus;

 soundplayed;
 vol;
 freq;

 cpx1;
 cpy1;
 cpx2;
 cpy2;

 numkills;

 alertness;
 disttocar;
 distcheck;

 lanenumber;

 police;

 sirenchannel;
 enginechannel;
 skidchannel;

 showframe;
 collisionid;
 aicollisionid;

 slideangle;
 moveangle;
 addangle;
 swerveangle;

 addheight;

 origangle;
 origy;

 crashed;

 dest_angle;
 increment;

 sirenangle;

 beeped;

BEGIN
 set_mode(m640x480);
 set_fps(30,0);

 vsync=1;

 particles[0]=new_map(1,1,0,0,15);
 particles[1]=new_map(1,1,0,0,223);
 particles[2]=new_map(1,1,0,0,221);
 particles[3]=new_map(1,1,0,0,219);
 particles[4]=new_map(1,1,0,0,79);
 particles[5]=new_map(1,1,0,0,78);
 particles[6]=new_map(1,1,0,0,77);
 particles[7]=new_map(1,1,0,0,76);
 particles[8]=new_map(1,1,0,0,75);
 particles[9]=new_map(1,1,0,0,74);
 particles[10]=new_map(1,1,0,0,73);
 particles[11]=new_map(1,1,0,0,22);

 sfont=load_fnt("wee.fnt");
 lfont=load_fnt("fat.fnt");

 music=load_wav("c:/mydocu~1/newfol~1/breakin.wav",1);
 carhitsound=load_wav("c:/div2/pcm/library/hints/shocks/crash.wav",0);
 pedhitsound=load_wav("c:/div2/pcm/library/hints/hints/golpe08.wav",0);
 policesound=load_wav("c:/div2/pcm/library/doorbell/sirens/sirena2.wav",1);
 enginesound=load_wav("c:/div2/pcm/engine.wav",1);
 skidsound=load_wav("c:/div2/pcm/library/efects/others/skid.wav",1);
 yellsound1=load_wav("c:/div2/pcm/library/humans/uah/uah00.wav",0);
 yellsound2=load_wav("c:/div2/pcm/library/humans/screams/grito.wav",0);
 yellsound3=load_wav("c:/div2/pcm/library/humans/screams/grito5.wav",0);
 bigcombosound=load_wav("c:/div2/big.wav",0);
 hugecombosound=load_wav("c:/div2/huge.wav",0);
 monstrouscombosound=load_wav("c:/div2/monstr~1.wav",0);
 yellsound4=load_wav("c:/div2/pcm/mom.wav",0);
 explosionsound=load_wav("c:/div2/pcm/library/wars/explosio/explos01.wav",0);
 hornsound1=load_wav("c:/div2/horn1.wav",0);
 hornsound2=load_wav("c:/div2/horn2.wav",0);

 load_fpg("c:/div2/fpg/car.fpg");

// save("hiscore.scr",&hiscore,sizeof(hiscore));
 load("hiscore.scr",&hiscore);

 playsound(music,256,256);

 start_scroll(0,0,4,0,0,1);

 carid=car();
 hud();

 credits();

 LOOP

  IF (gameover==0)
   policecounter++;
   prevdiff=difficulty;
   difficulty=1+(kills/10);
   IF (difficulty>30)
    difficulty=30;
   END
   IF (prevdiff<>difficulty)
    showcombo(5,0);
   END
  END

  IF (gameover>10 AND key(_space) AND carid==0)
   kills=0;
   gameover=0;
   score=0;
   carid=car();
  END

  busstopcounter+=rand(1,3);
  signcounter+=rand(1,2);

  IF (busstopcounter>550)
   busstopcounter=0;
   busstop();
  END

  IF (signcounter>80)
   signcounter=0;
   sign();
  END

  resetscroll=0;

  IF (gameover>0)
   gameover++;
   difficulty=1;
   policecounter=0;
   carlane=-1;
  END

  IF (combokills>0)
   combocounter++;
   IF (combocounter>90)
    combocounter=0;
    IF (combokills>27+(difficulty/4))
     writecombo(3,combokills);
     playsound(monstrouscombosound,256,256);
    ELSE
     IF (combokills>20+(difficulty/4))
      writecombo(2,combokills);
      playsound(hugecombosound,256,256);
     ELSE
      IF (combokills>13+(difficulty/4))
       writecombo(1,combokills);
       playsound(bigcombosound,256,256);
      END
     END
    END
    combokills=0;
   END
  END

  IF (policecounter>(1200-(difficulty*33)) AND gameover==0)
   policecounter=0;
   aicar(0,carid.y/10,4,1);
  END

  FOR (z=0;z<4;z++)
   lanecounter[z]++; //increments the ai car counters for each lane
  END

  lane=rand(0,3);

  IF (rand(1,4+((30-difficulty)/3))==1 AND lanecounter[0]>4+((30-difficulty)/3))
   lanecounter[0]=0;
   aicar(180000,1350,0,0);
  END

  IF (rand(1,4+((30-difficulty)/3))==1 AND lanecounter[1]>4+((30-difficulty)/3))
   lanecounter[1]=0;
   aicar(180000,2070,1,0);
  END

  IF (rand(1,8+((30-difficulty)/2))==1 AND lanecounter[2]>8+((30-difficulty)/2))
   lanecounter[2]=0;
   aicar(0,2780,2,0);
  END

  IF (rand(1,8+((30-difficulty)/2))==1 AND lanecounter[3]>8+((30-difficulty)/2))
   lanecounter[3]=0;
   aicar(0,3500,3,0);
  END

  IF (rand(1,26)==1)
   pedestrian(0,50);
  END
  IF (rand(1,26)==1)
   pedestrian(0,435);
  END

  findcars();

  scroll.x0+=20;   //sets the scroll position

  IF (scroll.x0>30000)
   resetscroll=1;
   scroll.x0-=60000;
  END

  write_int(sfont,145,15,3,&score);
  write_int(sfont,325,50,3,&difficulty);
  write(sfont,315,50,5,"Level:");

  FRAME;
 END
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS credits();
BEGIN

 graph=write_in_map(0,"Highway Havoc - Produced in DIV Games Studio 2 - Code and Graphics by Woody and Adherbal - Music by Judas Priest - Thanks to Madmax",6);
 x=640;
 y=477;

 LOOP

  x-=3;

  IF (out_region(id,0))
   BREAK;
  END

  FRAME;
 END
END




///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS hud();
BEGIN
 graph=1;
 flags=4;
 x=320;
 y=0;

 showhealth();

 signal(id,s_freeze);
 FRAME;
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS showhealth();
BEGIN

 graph=2;
 x=55;
 y=15;
 z=-10;

 define_region(1,17,8,76,15);
 region=1;

 LOOP

  IF (carid<>0)
   IF (carid.life>0)
    define_region(1,17,8,carid.life/66,15);
   END
  END

  FRAME;
 END
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS writecombo(number,numkills);
BEGIN
 x=359;
 y=13;

 IF (number==1)
  graph=write_in_map(sfont,"Big Combo",3);
 ELSE
  IF (number==2)
   graph=write_in_map(sfont,"Huge Combo",3);
  ELSE
   graph=write_in_map(sfont,"Monstrous Combo",3);
  END
 END

 life=80;

 LOOP

  life--;

  collisionid=collision(TYPE writecombo);

  IF (collisionid<>0)
   IF (collisionid.life>life)
    unload_map(graph);
    BREAK;
   END
  END

  IF (life<1)
   unload_map(graph);
   BREAK;
  END

  FRAME;
 END
END




///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS playsound(number,vol,freq);
PRIVATE
 goodtogo;

BEGIN

 goodtogo=0;

 FOR (z=24;z<32;z++)
  IF (is_playing_sound(z)==0)
   goodtogo=1;
  END
 END

 IF (goodtogo==1)
  sound(number,vol,freq);
 END

END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS showcombo(number,numkills);
PRIVATE
 text_id;
 STRING text;

BEGIN
 graph=20+number;

 IF (graph==25)
  size=50;
 END

 x=650;
 y=225;

 IF (number==5)
  y=50;
 END

 IF (number==4)
  y=200;
 END

 life=80;

 LOOP

  IF (life>35)
   x=320+get_distx(moveangle,320);
  ELSE
   x=0-get_disty(moveangle,320);
  END

  IF (life<20)
   moveangle+=4900;
  END

  IF (life>60)
   moveangle+=4100;
  END

  IF (life>20 AND life<60)
   moveangle=90000;
   x=320;
  END

  IF (collision(TYPE showcombo))
   y-=100;
  END

  life--;

  IF (number==4 AND life<40)
   life=40;
  END

  IF (number<4)
   text="Kills: "+itoa(numkills);
   text_id=write(sfont,x,y+30,4,text);
  END

  IF (gameover==1)
   life=0;
  END

  IF (life<1)
   IF (number<4)
    delete_text(text_id);
   END
   BREAK;
  END

  FRAME;
  IF (number<4)
   delete_text(text_id);
  END
 END
END




///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS showgameover();
PRIVATE
 text_id[4];
 STRING text1;
 STRING text2;

BEGIN
 graph=24;
 x=320;
 y=130;
 size=200;

 IF (score>hiscore)
  hiscore=score;
  save("hiscore.scr",&hiscore,sizeof(hiscore));
 END

 LOOP

  text1="Score: "+itoa(score);
  text2="High Score: "+itoa(hiscore);

  text_id[0]=write(sfont,320,y+60,4,text1);
  text_id[1]=write(sfont,320,y+80,4,text2);
  text_id[2]=write(sfont,320,y+120,4,"Press Space to restart");

  IF (gameover==0)
   delete_text(text_id[0]);
   delete_text(text_id[1]);
   delete_text(text_id[2]);
   BREAK;
  END

  FRAME;
  delete_text(text_id[0]);
  delete_text(text_id[1]);
  delete_text(text_id[2]);
 END
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS busstop();
BEGIN
 IF (rand(1,2)==1)
  y=101;
  flags=3;
 ELSE
  y=385;
  flags=0;
 END
 x=scroll.x0+640+144;
 z=scroll.z-50;

 IF (y>240)
  pedestrian(1,y+rand(0,38));
  pedestrian(1,y+rand(0,38));
  pedestrian(1,y+rand(0,38));
  pedestrian(1,y+rand(0,38));
  IF (rand(1,2)==1)
   pedestrian(1,y+rand(0,38));
  END
  IF (rand(1,2)==1)
   pedestrian(1,y+rand(0,38));
  END
  IF (rand(1,2)==1)
   pedestrian(1,y+rand(0,38));
  END
  IF (rand(1,2)==1)
   pedestrian(1,y+rand(0,38));
  END
 ELSE
  pedestrian(1,y+rand(-38,0));
  pedestrian(1,y+rand(-38,0));
  pedestrian(1,y+rand(-38,0));
  pedestrian(1,y+rand(-38,0));
  IF (rand(1,2)==1)
   pedestrian(1,y+rand(-38,0));
  END
  IF (rand(1,2)==1)
   pedestrian(1,y+rand(-38,0));
  END
  IF (rand(1,2)==1)
   pedestrian(1,y+rand(-38,0));
  END
  IF (rand(1,2)==1)
   pedestrian(1,y+rand(-38,0));
  END
 END

 ctype=c_scroll;

 graph=5;

 LOOP

  IF (x<scroll.x0-144)
   BREAK;
  END

  FRAME;
  IF (resetscroll==1)
   x-=60000*resolution;
  END
 END
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




PROCESS sign();
BEGIN
 graph=rand(51,55);
 x=scroll.x0+650;

 IF (rand(1,2)==1)
  y=97;
 ELSE
  y=389;
 END

 ctype=c_scroll;

 IF (collision(TYPE busstop))
  return();
 END

 addangle=rand(-28000,28000);
 addheight=rand(-30,60);

 LOOP

  IF (carid<>0)
   IF (carid.resolution<>0)
    IF (collision(TYPE car) AND abs(y-(carid.y/carid.resolution))<16)
     speed=120;
     addangle=rand(-46000,46000);
     playsound(carhitsound,rand(200,250),rand(120,390));
     moveangle=((angle+carid.angle)/2)+rand(-20000,20000);
     carid.life-=20;
     crashed=1;
    END
   END
  END

  IF (crashed==1)
   xadvance(moveangle,speed/4);
   angle+=addangle;
   z-=addheight;
   size=100-(z/15);

   IF (addheight>-60)
    addheight--;
   END

   IF (size<100)
    size=100;
   END

   IF (addangle>0)
    addangle-=70;
   END

   IF (addangle<0)
    addangle+=70;
   END

   IF (speed>0)
    speed-=2;
   END

   IF (size==100)
    speed-=3;
   END

   IF (size<110)
    collisionid=collision(TYPE car);
    IF (collisionid==0)
     collisionid=collision(TYPE aicar);
    ELSE
     playsound(carhitsound,rand(50,100),rand(120,390));
    END
   ELSE
    collisionid=0;
   END

   IF (collisionid<>0)
    moveangle=((angle+collisionid.angle)/2)+rand(-10000,10000);
    speed=((collisionid.speed/collisionid.resolution)*10)+rand(0,50);
    xadvance(moveangle,speed);
   END
  END

  IF (x<scroll.x0-10)
   BREAK;
  END

  FRAME;
  IF (resetscroll==1)
   x-=60000*resolution;
  END
 END
END




///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS findcars();
BEGIN

 FOR (z=0;z<40;z++)
  cars[z]=get_id(TYPE aicar);
 END

 FOR (z=0;z<10;z++)
//  write_int(0,20,20+(z*30),4,&cars[z]);
 END

END




///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS car();
BEGIN
 x=0;
 y=24300;
 resolution=100;

 ctype=c_scroll;

 graph=101;

 life=5000;

 enginechannel=sound(enginesound,256,200);

 LOOP

  showframe=1;

  change_sound(enginechannel,256,60+(speed/9));

  collisionid=collision(TYPE aicar);

  IF (collisionid<>0)
   IF (soundplayed==0)
    soundplayed=1;
    playsound(carhitsound,rand(50,100),rand(120,390));
   END
   IF (fps>15)
    particle(((x/10)+collisionid.x)/20,((y/10)+collisionid.y)/20,rand(1,10));
    particle(((x/10)+collisionid.x)/20,((y/10)+collisionid.y)/20,rand(1,10));
    particle(((x/10)+collisionid.x)/20,((y/10)+collisionid.y)/20,rand(1,10));
    particle(((x/10)+collisionid.x)/20,((y/10)+collisionid.y)/20,rand(1,10));
    particle(((x/10)+collisionid.x)/20,((y/10)+collisionid.y)/20,rand(1,10));
    particle(((x/10)+collisionid.x)/20,((y/10)+collisionid.y)/20,rand(1,10));
   END
   showframe=0;
   angle+=rand(-800,800);
   IF (collisionid.resolution<>0)
    xadvance(fget_angle(x/resolution,y/resolution,
             collisionid.x/collisionid.resolution,collisionid.y/collisionid.resolution),-4);
   ELSE
    xadvance(fget_angle(x/resolution,y/resolution,
             collisionid.x,collisionid.y),-4);
   END
   IF (collisionid.lanenumber<2)
    life-=45;
   END
   angle=fnear_angle(angle,fget_angle(collisionid.x/collisionid.resolution,collisionid.y/collisionid.resolution,
                                      x/resolution,y/resolution),6000)+rand(-2000,2000);
  END

  IF (angle>180000)
   angle-=360000;
  END
  IF (angle<-180000)
   angle+=360000;
  END

  IF (showframe==1)

   soundplayed=0;

   IF (life<2500)
//    graph=111;
   END

   IF (life<1250)
//    graph=112;
   END

   IF (speed>2000)
    speed=(speed*300)/301;    //automatic deceleration
   END

   IF ((speed/10)==200)
    speed=2000;
   END

   IF (life>1)
    advance(speed); //movement
   END

   IF (key(_up))
    speed+=40;
   END
                        //acceleration and braking
   IF (key(_down))
    IF (skidchannel==0)
     skidchannel=sound(skidsound,rand(200,256),rand(200,300));
    ELSE
     change_sound(skidchannel,rand(200,256),rand(200,300));
    END
    get_real_point(1,&cpx[0],&cpy[0]);
    get_real_point(2,&cpx[1],&cpy[1]);
    get_real_point(3,&cpx[2],&cpy[2]);
    get_real_point(4,&cpx[3],&cpy[3]);
    smoke(cpx[0]/resolution,cpy[0]/resolution,z+5,11,angle+rand(-5000,5000),8);
    smoke(cpx[1]/resolution,cpy[1]/resolution,z+5,11,angle+rand(-5000,5000),8);
    smoke(cpx[2]/resolution,cpy[2]/resolution,z+5,11,angle+rand(-5000,5000),8);
    smoke(cpx[3]/resolution,cpy[3]/resolution,z+5,11,angle+rand(-5000,5000),8);
    speed-=40;
   ELSE
    IF (skidchannel<>0)
     stop_sound(skidchannel);
     skidchannel=0;
    END
   END

   IF (key(_left))
    angle+=3000;
   END                  //turning

   IF (key(_right))
    angle-=3000;
   END

   IF (speed<100)
    speed+=50;
   END
                        //limits speed
   IF (speed>2400)
    speed-=50;
   END

   IF (angle>60000 AND life>0)
    angle=60000;
   END
                          //limits the angles
   IF (angle<-60000 AND life>0)
    angle=-60000;
   END

   IF (angle<9000 AND angle>-9000)
    IF (angle>0)
     angle-=800;
    END
    IF (angle<0)
     angle+=800;     //snaps the cars angle to 0
    END
    IF (angle<800 AND angle>-800)
     angle=0;
    END
   END

   IF ((x/100)<scroll.x0+10 AND life>0)
    IF (speed<2000)
     speed=2000;       //keeps the car from going offscreen
    END
    x=(scroll.x0+10)*100;
   END

   IF ((x/100)<scroll.x0-60 AND life<1)
    carid=0;
    BREAK;
   END

   IF ((x/100)>scroll.x0+630 AND life>0)
    IF (speed>2000)
     speed=2000;       //keeps the car from going offscreen
    END
    x=(scroll.x0+630)*100;
   END

   IF (y<0)
    y=0;
   END

   IF (y>48000)
    y=48000;
   END

   IF (y<38500)
    carlane=3;
   END
   IF (y<31400)
    carlane=2;
   END
   IF (y<24300)
    carlane=1;
   END
   IF (y<17200)
    carlane=0;
   END
   IF (y<10100 OR y>38500)
    carlane=-1;
   END

   IF (life<1500)
    smoke(x/resolution,y/resolution,z-5,31,angle,6);
   END
   IF (life<1200)
    smoke(x/resolution,y/resolution,z-5,31,angle,6);
   END
   IF (life<900)
    smoke(x/resolution,y/resolution,z-5,31,angle,6);
   END
   IF (life<600)
    smoke(x/resolution,y/resolution,z-5,31,angle,6);
   END
   IF (life<300)
    smoke(x/resolution,y/resolution,z-5,31,angle,6);
   END
   IF (life<150)
    smoke(x/resolution,y/resolution,z-5,31,angle,6);
   END

   IF (life<1)
    IF (rand(1,2)==1)
     addangle=rand(-30000,-20000);
    ELSE
     addangle=rand(20000,30000);
    END
    gameover=1;
    showgameover();
    IF (skidchannel<>0)
     stop_sound(skidchannel);
    END
    IF (enginechannel<>0)
     stop_sound(enginechannel);
    END
    slideangle=angle;
    IF (exploded==0)
     exploded=1;
     sound(explosionsound,150,200);
    END
    xadvance(slideangle,speed);
    speed-=50;
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,11,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,11,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,11,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,11,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,11,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,11,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,31,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,31,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,31,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,31,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,31,angle,speed/resolution);
    smoke((x/resolution)+rand(-15,15),(y/resolution)+rand(-15,15),z-5,31,angle,speed/resolution);
    angle+=addangle;
   END

   shadow(0);

   FRAME;

  END
  IF (resetscroll==1)
   x-=60000*resolution;
  END
 END
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS aicar(angle,y,lanenumber,police);
BEGIN

 IF (police==1)
  graph=6;
 ELSE
  IF (rand(1,6)==1)
   graph=rand(107,110);
  ELSE
   graph=rand(102,106);
  END
 END

 IF (police==0)
  x=(scroll.x0+660)*10;
 ELSE
  x=(scroll.x0-20)*10;
  speed=250;
 END
 y+=rand(-10,10);
 resolution=10;

 ctype=c_scroll;

 origangle=angle;
 origy=y;

 alertness=rand(20,130);

 IF (rand(1,2)==1)
  swerveangle=3000;
 ELSE
  swerveangle=-3000;
 END

 IF (police==1)
  sirenchannel=sound(policesound,0,256);
 END

 beeped=31;

 LOOP

  showframe=1;

  IF (crashed==0)
   collisionid=collision(TYPE car);
  ELSE
   collisionid=0;
  END

  IF (police==1 AND crashed==0)
   IF (carid<>0)
    IF (carid.resolution<>0)
     change_sound(sirenchannel,256-(fget_dist(x/resolution,y/resolution,
                                   carid.x/carid.resolution,carid.y/carid.resolution)/5),256);
    END
   END
   IF (gameover<>0)
    stop_sound(sirenchannel);
    BREAK;
   END
  END

  IF (collisionid<>0)
   IF (soundplayed==0)
    soundplayed=1;
    playsound(carhitsound,rand(50,100),rand(120,390));
   END
   IF (lanenumber=>2 AND lanenumber<>4)
    IF (carid<>0)
     carid.life-=abs((speed/resolution)-(collisionid.speed/collisionid.resolution))/20;
    END
   END
   addangle+=rand(-800,800);
   showframe=0;
   IF (collisionid.resolution<>0)
    xadvance(fget_angle(x/resolution,y/resolution,
             collisionid.x/collisionid.resolution,collisionid.y/collisionid.resolution),-4);
   ELSE
    xadvance(fget_angle(x/resolution,y/resolution,
             collisionid.x,collisionid.y),-4);
   END
  END

  aicollisionid=collision(TYPE aicar);

  IF (aicollisionid<>0)
   IF (soundplayed==0)
    soundplayed=1;
    playsound(carhitsound,rand(50,100),rand(120,390));
   END
   xadvance(fget_angle(x,y,aicollisionid.x,aicollisionid.y),-30);
   IF (fps>15)
    particle((x+aicollisionid.x)/20,(y+aicollisionid.y)/20,rand(1,10));
    particle((x+aicollisionid.x)/20,(y+aicollisionid.y)/20,rand(1,10));
    particle((x+aicollisionid.x)/20,(y+aicollisionid.y)/20,rand(1,10));
    particle((x+aicollisionid.x)/20,(y+aicollisionid.y)/20,rand(1,10));
    particle((x+aicollisionid.x)/20,(y+aicollisionid.y)/20,rand(1,10));
    particle((x+aicollisionid.x)/20,(y+aicollisionid.y)/20,rand(1,10));
   END
  END

  IF (aicollisionid<>0 AND showframe==1 AND crashed==0 AND police==1)
    angle=fnear_angle(angle,fget_angle(aicollisionid.x/aicollisionid.resolution,aicollisionid.y/aicollisionid.resolution,
                                       x/resolution,y/resolution),14000)+rand(-10000,10000);
  END

  IF (aicollisionid<>0 AND crashed==0 AND police==0)
   combokills+=4;
   kills+=4;
   score+=10*(combokills*(combokills/3));
   policecounter+=30;
   slideangle=angle;
   addangle=rand(12000,25000);
   IF (rand(1,2)==1)
    addangle*=-1;
   END
   speed=100;
   IF (rand(1,2)==1)
    get_real_point(5,&cpx[4],&cpy[4]);
    body(cpx[4],cpy[4],slideangle,speed+20,rand(44,46));
   END
   IF (rand(1,6)==1)
    get_real_point(6,&cpx[5],&cpy[5]);
    body(cpx[5]/resolution,cpy[5]/resolution,slideangle,speed+20,rand(44,46));
   END
   crashed=1;
  END

  IF (((lanenumber=>2 AND (angle<-50000 OR angle>50000)) OR
      ((lanenumber<2 AND ((angle>-130000 AND angle<-100000) OR (angle<130000 AND angle>100000))))) AND crashed==0)
   combokills+=4;
   kills+=4;
   score+=10*(combokills*(combokills/3));
   slideangle=angle;
   IF (lanenumber=>2)
    addangle=angle/6;
   ELSE
    addangle=-angle/9;
   END
   speed=100;
   crashed=1;
  END

  IF (crashed==1)
   speed-=2;
   IF (police==1)
    change_sound(sirenchannel,256,speed);
   END
  END

  IF ((x/10)<scroll.x0-60)
   stop_sound(sirenchannel);
   BREAK;
  END

  IF (angle>180000)
   angle-=360000;
  END
  IF (angle<-180000)
   angle+=360000;
  END

  IF (police<>0 AND collision(TYPE car))
   IF (carid<>0)
    carid.life-=20+abs((speed/resolution)-(carid.speed/carid.resolution));
   END
  END

  IF (showframe==1)

   soundplayed=0;
   beeped++;

   IF (collisionid<>0)
    IF (fps>15)
     particle((x+(collisionid.x/10))/20,(y+(collisionid.y/10))/20,rand(1,10));
     particle((x+(collisionid.x/10))/20,(y+(collisionid.y/10))/20,rand(1,10));
     particle((x+(collisionid.x/10))/20,(y+(collisionid.y/10))/20,rand(1,10));
     particle((x+(collisionid.x/10))/20,(y+(collisionid.y/10))/20,rand(1,10));
     particle((x+(collisionid.x/10))/20,(y+(collisionid.y/10))/20,rand(1,10));
     particle((x+(collisionid.x/10))/20,(y+(collisionid.y/10))/20,rand(1,10));
    END
    angle=fnear_angle(angle,fget_angle(collisionid.x/collisionid.resolution,collisionid.y/collisionid.resolution,
                                       x/resolution,y/resolution),14000)+rand(-10000,10000);
   END

   IF (carid<>0)
    disttocar=fget_dist(x/10,y/10,carid.x/100,carid.y/100);
   END

   IF (lanenumber=>2  AND lanenumber<>4 AND disttocar<alertness AND abs(angle-origangle)<alertness*300 AND carid<>0)
    angle=fnear_angle(angle,fget_angle(carid.x/carid.resolution,carid.y/carid.resolution,
                                       x/resolution,y/resolution),4000)+rand(-2000,2000);
    IF (beeped>30)
     beeped=0;
     IF (rand(1,5)==1)
      playsound(hornsound1,130,256);
     ELSE
      IF (rand(1,4)==1)
       playsound(hornsound2,160,256);
      END
     END
    END
   END

   IF (lanenumber==4 AND abs(angle-origangle)=>10000)
    angle=fnear_angle(angle,0,1000);
   END

   IF (lanenumber==4 AND abs(angle-origangle)<10000 AND carid<>0)
    angle=fnear_angle(angle,fget_angle(x/resolution,y/resolution,
                                       carid.x/carid.resolution,carid.y/carid.resolution),1000);
   END

   IF (lanenumber<2 AND disttocar<alertness*2 AND abs(angle-origangle)<alertness*600)
//    angle=near_angle(angle,fget_angle(carid.x/carid.resolution,carid.y/carid.resolution,
//                                       x/resolution,y/resolution),4000)+rand(-2000,2000);
   END

   IF (lanenumber<2 AND carlane==lanenumber)
    angle+=swerveangle+((800-disttocar)*4);
    IF (beeped>30)
     beeped=0;
     IF (rand(1,5)==1)
      playsound(hornsound1,200,256);
     ELSE
      IF (rand(1,4)==1)
       playsound(hornsound2,200,256);
      END
     END
    END
   END

/*
   FOR (distcheck=0;distcheck<20;distcheck++)
    IF (cars[distcheck]<>0)
     IF (fget_dist(x/10,y/10,cars[distcheck].x/10,cars[distcheck].y/10)<alertness/2)
      angle=near_angle(angle,fget_angle(cars[distcheck].x,cars[distcheck].y,x,y),4000)+rand(-2000,2000);
     END
    END
   END
*/

   IF (crashed==0)
    IF (police==0)
     angle=fnear_angle(angle,fget_angle(x,y,x+get_distx(origangle,600),origy),1200);
     advance(70);
    ELSE
     advance(speed);
     IF (carid<>0)
      IF (x/resolution>carid.x/carid.resolution)
       speed-=5;
      ELSE
       speed+=5;
      END
     END
     IF (speed>250)
      speed=250;
     END
     IF (speed<70)
      speed=70;
     END
    END
   ELSE
    get_real_point(1,&cpx[0],&cpy[0]);
    get_real_point(2,&cpx[1],&cpy[1]);
    get_real_point(3,&cpx[2],&cpy[2]);
    get_real_point(4,&cpx[3],&cpy[3]);
    smoke(cpx[0]/resolution,cpy[0]/resolution,z+5,11,angle+rand(-8000,8000),8);
    smoke(cpx[1]/resolution,cpy[1]/resolution,z+5,11,angle+rand(-8000,8000),8);
    smoke(cpx[2]/resolution,cpy[2]/resolution,z+5,11,angle+rand(-8000,8000),8);
    smoke(cpx[3]/resolution,cpy[3]/resolution,z+5,11,angle+rand(-8000,8000),8);
    xadvance(slideangle,speed);
   END

   angle+=addangle;
   addangle=(addangle*11)/12;

   IF (police==1)
    shadow(10);
    get_real_point(7,&cpx1,&cpy1);
    get_real_point(8,&cpx2,&cpy2);
    siren(1,cpx1/10,cpy1/10);
    siren(2,cpx2/10,cpy2/10);
    sirenangle+=20000;
   ELSE
    shadow(graph-101);
   END

   FRAME;
  END
  IF (resetscroll==1)
   x-=60000*resolution;
  END
 END
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS shadow(number);
PRIVATE
 gw;
 gh;

BEGIN

 IF (carshadows[number]==0)
  gw=graphic_info(0,father.graph,g_wide);
  gh=graphic_info(0,father.graph,g_height);
  carshadows[number]=new_map(gw,gh,gw/2,gh/2,0);
  FOR (x=0;x<gw;x++)
   FOR (y=0;y<gh;y++)
    IF (map_get_pixel(0,father.graph,x,y)<>0)
     map_put_pixel(0,carshadows[number],x,y,1);
    END
   END
  END
 END

 graph=carshadows[number];
 x=(father.x/father.resolution)+7;
 y=(father.y/father.resolution)+7;
 z=father.z+10;
 angle=father.angle;
 ctype=c_scroll;
 flags=4;

 FRAME;
END




///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS siren(number,x,y);
BEGIN
 graph=6+number;

 ctype=c_scroll;

 z=-50;

 IF (number==1)
  angle=father.sirenangle;
 ELSE
  angle=father.sirenangle+90000;
 END

 light(number,angle);

 FRAME;
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS light(number,angle);
BEGIN
 graph=8+number;
 size=50;
 flags=4;

 x=father.x;
 y=father.y;
 z=-51;

 ctype=c_scroll;

 FRAME;
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS pedestrian(bus,y);
BEGIN
 graph=rand(41,43);

 IF (bus==0)
  x=scroll.x0+650;
  y+=rand(-40,40);
 ELSE
  x=father.x+rand(-74,74);
 END
 z=-50;

 ctype=c_scroll;

 IF (rand(1,2)==1)
  addspeed=-1;
 ELSE
  addspeed=1;
 END

 IF (rand(1,2)==1)
  xspeed=rand(3,6);
  flags=1;
 ELSE
  xspeed=rand(-3,6);
  flags=0;
 END

 IF (bus==1)
  xspeed=0;
 END

 LOOP

  x+=xspeed;
  y+=speed;

  IF (y<5)
   y=5;
  END

  IF (y>475)
   y=475;
  END

  IF (speed>6)
   speed=6;
  END

  IF (speed<-6)
   speed=-6;
  END

  collisionid=collision(TYPE car);
  IF (collisionid==0)
   collisionid=collision(TYPE aicar);
  ELSE
   IF (carid<>0)
    carid.life-=12;
   END
   playsound(pedhitsound,rand(100,120),rand(220,290));
   playsound(carhitsound,rand(50,100),rand(120,390));
  END

  IF (collisionid<>0)
   IF (fps>15)
    particle(x,y,11);
    particle(x,y,11);
    particle(x,y,11);
    particle(x,y,11);
    particle(x,y,11);
    particle(x,y,11);
    particle(x,y,11);
    particle(x,y,11);
    particle(x,y,11);
    particle(x,y,11);
   END
   combokills++;
   kills++;
   score+=3*(combokills*((combokills/8)+1));
   policecounter+=10;
   body(x*10,y*10,rand(-180000,180000),(collisionid.speed/collisionid.resolution)*10,graph+3);
   IF (graph<>43)
    SWITCH (rand(1,8))
     CASE 1:
      playsound(yellsound1,200,256);
     END
     CASE 2:
      playsound(yellsound2,250,256);
     END
     CASE 3:
      playsound(yellsound3,130,256);
     END
    END
   ELSE
    IF (rand(1,3)==1)
     playsound(yellsound4,100,256);
    END
   END
   BREAK;
  END

  IF (carid<>0)
   IF (gameover==0 AND (carid.y/100)<y+10 AND (carid.y/100)>y-10)
    speed+=addspeed;
   END
  END

  IF (x<scroll.x0-20)
   BREAK;
  END

  FRAME;
  IF (resetscroll==1)
   x-=60000*resolution;
  END
 END
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS body(x,y,moveangle,speed,graph);
BEGIN
 ctype=c_scroll;

 z=0;
 resolution=10;

 addangle=rand(-28000,28000);
 addheight=rand(-30,60);
 speed=120;

 blood(x/resolution,y/resolution);

 LOOP

  IF (fps>15)
   particle(x/10,y/10,11);
  END

  xadvance(moveangle,speed);
  angle+=addangle;
  z-=addheight;
  size=100-(z/15);

  IF (addheight>-60)
   addheight--;
  END

  IF (size<100)
   size=100;
  END

  IF (addangle>0)
   addangle-=150;
  END

  IF (addangle<0)
   addangle+=150;
  END

  IF (speed>0)
   speed-=2;
  END

  IF (size==100)
   speed-=3;
  END

  IF (size<110)
   collisionid=collision(TYPE car);
   IF (collisionid==0)
    collisionid=collision(TYPE aicar);
   ELSE
    playsound(pedhitsound,rand(100,120),rand(220,290));
    playsound(carhitsound,rand(50,100),rand(120,390));
   END
  ELSE
   collisionid=0;
  END

  IF (collisionid<>0)
   blood(x/resolution,y/resolution);
   moveangle=((angle+collisionid.angle)/2)+rand(-20000,20000);
   speed=((collisionid.speed/collisionid.resolution)*10)+rand(0,50);
   xadvance(moveangle,speed);
  END

  IF (x<(scroll.x0-20)*10 OR x>(scroll.x0+660)*10)
   BREAK;
  END

  FRAME;
  IF (resetscroll==1)
   x-=60000*resolution;
  END
 END
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS blood(x,y);
BEGIN
 graph=61;
 angle=rand(-180000,180000);
 z=200;

 ctype=c_scroll;

 LOOP

  IF (x<scroll.x0)
   BREAK;
  END

  FRAME;
 END
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS smoke(x,y,z,startgraph,angle,speed);
BEGIN
 graph=startgraph;
 flags=4;

 x+=rand(-6,6);
 y+=rand(-6,6);

 ctype=c_scroll;

 size=rand(10,20);

 IF (carid<>0)
  IF (father==carid AND carid.life<1)
   size=rand(70,100);
  END
 END

 LOOP

  graph++;
  size+=6;
  advance(speed);

  IF (graph>startgraph+6 OR x<scroll.x0 OR x>scroll.x0+640 OR y<0 OR y>480)
   BREAK;
  END

  FRAME;
  IF (resetscroll==1)
   x-=60000*resolution;
  END
 END
END





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS particle(x,y,graph);
PRIVATE
 randnum;
 randnum2;

BEGIN
 IF (graph==11)
  size=100+(rand(0,1)*100);
 END

 graph=particles[graph];
 moveangle=rand(-180000,180000);
 speed=rand(0,30);
 life=rand(6,15);

 x+=get_distx(moveangle,rand(-10,10));
 y+=get_disty(moveangle,rand(-10,10));

 resolution=10;
 x*=10;
 y*=10;
 z=-100;

 ctype=c_scroll;

 LOOP

  life--;
  xadvance(moveangle,speed);

  IF (graph==particles[11])
   collisionid=collision(TYPE car);
   IF (collisionid<>0)
    randnum=rand(-4,-1);
    IF (rand(1,2)==1)
     randnum=rand(-8,-1);
    END
    IF (rand(1,3)==1)
     randnum=rand(-12,-1);
    END
    IF (rand(1,4)==1)
     randnum=rand(-16,-1);
    END
    IF (rand(1,5)==1)
     randnum=rand(-20,-1);
    END
    IF (rand(1,6)==1)
     randnum=rand(-24,-1);
    END
    IF (rand(1,7)==1)
     randnum=rand(-28,-1);
    END
    IF (rand(1,8)==1)
     randnum=rand(-32,-1);
    END
    randnum2=rand(0,graphic_info(0,collisionid.graph,g_height));
    IF (map_get_pixel(0,collisionid.graph,graphic_info(0,collisionid.graph,g_wide)+randnum,randnum2)<>0)
     map_xput(0,collisionid.graph,particles[11],graphic_info(0,collisionid.graph,g_wide)+randnum,randnum2,
              0,100,4);
    END
    BREAK;
   END
  END

  IF (life<1)
   BREAK;
  END

  FRAME;
  IF (resetscroll==1)
   x-=60000*resolution;
  END
 END
END




///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





PROCESS fnear_angle(angle,dest_angle,increment);
BEGIN

 IF (dest_angle>angle)
  IF (dest_angle-angle<=180000)
   IF (dest_angle-angle=>increment)
    angle+=increment;
   ELSE
    angle=dest_angle;
   END
  ELSE
   IF (dest_angle+(360-angle)=>increment)
    angle-=increment;
   ELSE
    angle=dest_angle;
   END
  END
 ELSE
  IF (angle-dest_angle<=180000)
   IF (angle-dest_angle=>increment)
    angle-=increment;
   ELSE
    angle=dest_angle;
   END
  ELSE
   IF (angle+(360-dest_angle)=>increment)
    angle+=increment;
   ELSE
    angle=dest_angle;
   END
  END
 END

 return(angle);

END